SystemOrganization addCategory: #'Poll-Commands'!
SystemOrganization addCategory: #'Poll-Model'!
SystemOrganization addCategory: #'Poll-Visitor'!

PREditCommand subclass: #POEditPollCommand
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-Commands'!

!POEditPollCommand class methodsFor: 'accessing' stamp: 'pmm 12/18/2005 20:18'!
defaultStructureClass
	^POPoll! !

!POEditPollCommand class methodsFor: 'accessing-description' stamp: 'pmm 12/18/2005 20:19'!
descriptionOptions
	^POPoll descriptionOptions ! !

!POEditPollCommand class methodsFor: 'accessing-description' stamp: 'pmm 12/18/2005 20:06'!
descriptionTitle
	^POPoll descriptionTitle! !

!POEditPollCommand class methodsFor: 'testing' stamp: 'pmm 12/18/2005 20:06'!
isAbstract
	^false! !

!POEditPollCommand methodsFor: 'events' stamp: 'pmm 12/18/2005 20:21'!
doExecute
	super doExecute.
	self structure options: self options.! !

!POEditPollCommand methodsFor: 'events' stamp: 'pmm 12/23/2005 00:02'!
doInitialize
	super doInitialize.
	self options: self structure options! !

!POEditPollCommand methodsFor: 'accessing' stamp: 'pmm 12/18/2005 20:21'!
options
	^options! !

!POEditPollCommand methodsFor: 'accessing' stamp: 'pmm 12/18/2005 20:21'!
options: aCollection 
	options := aCollection! !

MADistribution subclass: #P0Distribution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-Model'!

!P0Distribution class methodsFor: 'accessing' stamp: 'pmm 1/28/2006 09:59'!
package
	"The SqueakMap package name."

	^ 'Poll'! !

!P0Distribution class methodsFor: 'accessing' stamp: 'pmm 1/28/2006 09:59'!
packages
	^ #( ( 'Poll' ) )! !

!P0Distribution class methodsFor: 'accessing' stamp: 'pmm 1/28/2006 10:00'!
version
	"The first item is the product name, which should only contain lowercase letters. Then the version numbers are following, that are made up of three numbers. An optimal suffix alpha, beta, pre or rc follows. External packages or extensions might want to call this method to check the version required to run."

	^ #( poll 0 9 0 pre1 )! !

PRObject subclass: #POPollOption
	instanceVariableNames: 'text votes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-Model'!

!POPollOption class methodsFor: 'accessing-description' stamp: 'pmm 12/18/2005 15:42'!
descriptionText
	^(MAStringDescription selector: #text label: 'Text' priority: 100)
		beRequired;
		yourself! !

!POPollOption class methodsFor: 'accessing-description' stamp: 'pmm 12/18/2005 15:42'!
descriptionVotes
	^(MANumberDescription selector: #votes label: 'Votes' priority: 200)
		default: 0;
		beHidden;
		yourself! !

!POPollOption class methodsFor: 'testing' stamp: 'pmm 12/18/2005 15:39'!
isAbstract
	^false! !

!POPollOption methodsFor: 'actions' stamp: 'pmm 12/22/2005 16:45'!
addVote
	self votes: self votes + 1! !

!POPollOption methodsFor: 'testing' stamp: 'pmm 1/3/2006 10:13'!
hasVotes
	^self votes notEmpty! !

!POPollOption methodsFor: 'accessing' stamp: 'pmm 12/22/2005 16:28'!
label
	^self text! !

!POPollOption methodsFor: 'printing' stamp: 'pmm 12/22/2005 16:34'!
printOn: aStream
	super printOn: aStream.
	self text isNil ifFalse: [
		aStream
			nextPut: $(;
			nextPutAll: self text;
			nextPut: $) ]! !

!POPollOption methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:38'!
text
	^text! !

!POPollOption methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:43'!
text: aString 
	text := aString! !

!POPollOption methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:38'!
votes
	^votes! !

!POPollOption methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:43'!
votes: anInteger 
	votes := anInteger! !

MAStringWriter subclass: #POLabelWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-Visitor'!

!POLabelWriter methodsFor: 'visiting' stamp: 'pmm 12/22/2005 16:27'!
write: anObject description: aDescription
	^anObject label! !

PRCommand subclass: #POVoteCommand
	instanceVariableNames: 'vote'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-Commands'!

!POVoteCommand class methodsFor: 'accessing' stamp: 'pmm 12/18/2005 16:29'!
defaultStructureClass
	^POPoll ! !

!POVoteCommand class methodsFor: 'testing' stamp: 'pmm 1/28/2006 10:28'!
hasAlreadyVoted
	| cookies poll |
	cookies := WACurrentSession value currentRequest cookies.
	poll := PRCurrentContext value structure.
	^(cookies includesKey: poll cookieName)! !

!POVoteCommand class methodsFor: 'testing' stamp: 'pmm 12/22/2005 16:21'!
isAbstract
	^false! !

!POVoteCommand class methodsFor: 'testing' stamp: 'pmm 1/28/2006 10:24'!
isHttp
	^WACurrentSession value notNil! !

!POVoteCommand class methodsFor: 'testing' stamp: 'pmm 1/28/2006 10:26'!
isValidIn: aContext
	^(super isValidIn: aContext)
		and: [ self isHttp not or: [ self hasAlreadyVoted not ] ]! !

!POVoteCommand class methodsFor: 'accessing' stamp: 'pmm 12/18/2005 16:28'!
label
	^'Vote'! !

!POVoteCommand methodsFor: 'private' stamp: 'pmm 1/28/2006 10:22'!
addCookie
	| voteCookie |
	voteCookie := (WACookie
		key: self structure cookieName
		value: true displayString)
		expiry: (DateAndTime year: 2095 month: 1 day: 1 hour: 12 minute: 0);
		yourself.
	self session redirectWithCookies: (Array with: voteCookie)! !

!POVoteCommand methodsFor: 'accessing-description' stamp: 'pmm 12/22/2005 16:38'!
description
	^super description copy
		add: self descriptionVote;
		yourself! !

!POVoteCommand methodsFor: 'accessing-description' stamp: 'pmm 12/22/2005 16:38'!
descriptionVote
	^(MASingleOptionDescription selector: #vote label: 'Vote' priority: 200)
		options: self options;
		reference: (POPollOption description
			stringWriter: POLabelWriter;
			yourself);
		componentClass: MARadioGroupComponent;
		beRequired;
		yourself! !

!POVoteCommand methodsFor: 'events' stamp: 'pmm 1/28/2006 10:23'!
doExecute
	super doExecute.
	self vote addVote.
	self isHttp
		ifTrue: [ self addCookie ]! !

!POVoteCommand methodsFor: 'testing' stamp: 'pmm 1/28/2006 10:24'!
isHttp
	^self class isHttp ! !

!POVoteCommand methodsFor: 'accessing' stamp: 'pmm 12/18/2005 16:29'!
options
	^self structure options! !

!POVoteCommand methodsFor: 'accessing' stamp: 'pmm 12/18/2005 16:36'!
vote
	^vote! !

!POVoteCommand methodsFor: 'accessing' stamp: 'pmm 12/18/2005 16:36'!
vote: anObject
	vote := anObject! !

PRStructure subclass: #POPoll
	instanceVariableNames: 'options uuid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-Model'!

!POPoll class methodsFor: 'accessing-description' stamp: 'pmm 12/18/2005 20:34'!
descriptionOptions
	^(MAOneToManyRelationDescription selector: #options label: 'Options' priority: 200)
		classes: (Array with: POPollOption);
		default: OrderedCollection new;
		yourself.! !

!POPoll class methodsFor: 'accessing-description' stamp: 'pmm 12/18/2005 16:37'!
descriptionTitle
	^super descriptionTitle
		label: 'Question';
		yourself! !

!POPoll class methodsFor: 'accessing-description' stamp: 'pmm 1/28/2006 10:04'!
descriptionUUID
	^ (MAStringDescription selector: #uuid label: 'UUId' priority: 1000)
		beHidden;
		beReadonly;
		yourself.! !

!POPoll class methodsFor: 'testing' stamp: 'pmm 12/18/2005 15:45'!
isAbstract
	^false! !

!POPoll class methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:48'!
label
	^'Poll'! !

!POPoll methodsFor: 'visiting' stamp: 'pmm 12/18/2005 17:08'!
accept: aVisitor
	aVisitor visitPoll: self.! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 1/28/2006 10:20'!
cookieName
	^'pierPoll' , self uuid! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 12/18/2005 20:19'!
editCommand
	^POEditPollCommand new! !

!POPoll methodsFor: 'initialize-release' stamp: 'pmm 1/28/2006 10:03'!
initialize
	super initialize.
	uuid := UUID new printString.
	self options: OrderedCollection new! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:44'!
options
	^options! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:44'!
options: aCollection 
	options := aCollection! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:45'!
totalVotes
	^self options inject: 0 into: [ :sum :each |
		sum + each votes ]! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 1/28/2006 10:02'!
uuid
	^uuid! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 12/18/2005 20:36'!
viewCommand
	^PRViewCommand new
		viewComponentClass: POPollResultsView;
		yourself! !

PRViewComponent subclass: #POPollResultsView
	instanceVariableNames: 'chart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-Commands'!

!POPollResultsView class methodsFor: 'testing' stamp: 'pmm 12/18/2005 16:44'!
isAbstract
	^false! !

!POPollResultsView class methodsFor: 'testing' stamp: 'pmm 12/18/2005 17:07'!
isValidIn: aContext
	^(super isValidIn: aContext)
		and: [ aContext structure isKindOf: POPoll ]! !

!POPollResultsView class methodsFor: 'accessing' stamp: 'pmm 12/22/2005 16:20'!
label
	^'View Results'! !

!POPollResultsView methodsFor: 'accessing' stamp: 'pmm 12/22/2005 21:50'!
chart
	^chart! !

!POPollResultsView methodsFor: 'accessing' stamp: 'pmm 12/22/2005 17:12'!
chart: anObject
	chart := anObject! !

!POPollResultsView methodsFor: 'accessing' stamp: 'pmm 12/22/2005 17:13'!
children
	^Array with: self chart! !

!POPollResultsView methodsFor: 'accessing' stamp: 'pmm 12/22/2005 21:50'!
context
	^super context ifNil: [ PRCurrentContext value ]! !

!POPollResultsView methodsFor: 'private' stamp: 'pmm 12/23/2005 22:18'!
createPieChart
	self chart: CGPieChart new.
	self chart addDataset: self dataset.
	self chart xLabels: self xLabels.
	self chart fontSize: 12.
	self chart labelWidth: 100.
	self chart width: 400 height: 400.
	self chart paddingTop: 50 left: 50 bottom: 50 right: 50.
	self chart id: 'result' , self poll title! !

!POPollResultsView methodsFor: 'private' stamp: 'pmm 1/3/2006 10:14'!
dataset
	| index data |
	index := 0.
	data := self pollOptionsWithVotes collect: [ :each |
		index := index + 1.
		Array with: index with: each votes ].
	^CGDataset name: self poll title data: data! !

!POPollResultsView methodsFor: 'initialize-release' stamp: 'pmm 12/22/2005 21:50'!
initialize
	super initialize.
	self createPieChart! !

!POPollResultsView methodsFor: 'accessing' stamp: 'pmm 12/18/2005 17:11'!
poll
	^self context structure! !

!POPollResultsView methodsFor: 'accessing' stamp: 'pmm 12/18/2005 17:11'!
pollOptions
	^self poll options! !

!POPollResultsView methodsFor: 'accessing' stamp: 'pmm 1/3/2006 10:14'!
pollOptionsWithVotes
	^self pollOptions select: [ :each | each hasVotes ]! !

!POPollResultsView methodsFor: 'rendering' stamp: 'pmm 12/22/2005 17:17'!
renderContentOn: html
	html render: self chart! !

!POPollResultsView methodsFor: 'rendering' stamp: 'pmm 12/18/2005 17:10'!
rendererClass
	^WARenderCanvas ! !

!POPollResultsView methodsFor: 'private' stamp: 'pmm 1/3/2006 10:14'!
xLabels
	| index labels |
	labels := Dictionary new.
	index := 0.
	self pollOptionsWithVotes collect: [ :each |
		index := index + 1.
		labels at: index put: each text ].
	^labels! !

!PRVisitor methodsFor: '*Poll' stamp: 'pmm 12/18/2005 17:07'!
visitPoll: aPoll
	self visitStructure: aPoll! !
